
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Training &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Training</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">torch.nn</span> <span class="k">as</span> <span class="nn">nn</span>
<span class="kn">from</span> <span class="nn">Report</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>

<div class="viewcode-block" id="Train"><a class="viewcode-back" href="../sphinx/Training.html#Training.Train">[docs]</a><span class="k">def</span> <span class="nf">Train</span><span class="p">(</span><span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">model</span><span class="p">,</span> <span class="n">N_epochs</span><span class="p">,</span> <span class="n">loss_fn</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
          <span class="n">optimizer</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">parameters</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">LR</span><span class="o">=</span><span class="mf">5e-6</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
          <span class="n">remove_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;TEST&#39;</span><span class="p">,</span> <span class="n">report_name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
          <span class="n">sim_loader</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">Training_info</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="s1">&#39;cpu&#39;</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>

    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function for training pytorch neural network models.</span>
<span class="sd">    It takes in two DataLoader classes, for the training and validation sets,</span>
<span class="sd">    a torch.nn.Module model, the number of epochs and the learning rate. From</span>
<span class="sd">    that, it trains the model and automatically calculates what the best epoch</span>
<span class="sd">    was.</span>

<span class="sd">    .. warning::</span>
<span class="sd">        You may find references about this function&#39;s ``report`` or</span>
<span class="sd">        ``plot_bool`` arguments in some parts of the documentation.</span>
<span class="sd">        They are deprecated since August 18th 2021 (they don&#39;t appear in the</span>
<span class="sd">        function anymore). The function will act as if they were ``True``.</span>

<span class="sd">        The code still works if you include them in the arguments, it will just</span>
<span class="sd">        show a warning (except in google colab because it apparently suppresses</span>
<span class="sd">        warnings).</span>

<span class="sd">        The ``report`` argument in :func:`~Training.simulate` is still useful</span>
<span class="sd">        and used.</span>

<span class="sd">    A report folder is created inside the &quot;Reports&quot; directory (if it doesn&#39;t</span>
<span class="sd">    exist one is created). The user can add a name to the specific report folder</span>
<span class="sd">    through the ``report_name`` argument. Either way, the name is followed by</span>
<span class="sd">    the date and time of the training in order to avoid overwriting.</span>

<span class="sd">    To know more about report folder, check the documentation for</span>
<span class="sd">    :std:doc:`Report`.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    report_name</span>
<span class="sd">    train_loader : torch.utils.data.DataLoader</span>
<span class="sd">        The training dataset&#39;s DataLoader class.</span>
<span class="sd">    valid_loader : torch.utils.data.DataLoader</span>
<span class="sd">        The validation dataset&#39;s DataLoader class.</span>
<span class="sd">    model : torch.nn.Module</span>
<span class="sd">        The model to be trained.</span>
<span class="sd">    N_epochs : int</span>
<span class="sd">        The number of epochs.</span>
<span class="sd">    loss_fn : th.nn Loss function, optional</span>
<span class="sd">        The loss function.</span>
<span class="sd">    optimizer : th.nn Optimizer, optional</span>
<span class="sd">        The optimizer.</span>
<span class="sd">    LR : float, default = 5e-6</span>
<span class="sd">        The learning rate.</span>
<span class="sd">    print_bool : bool, default = False</span>
<span class="sd">        If we want to print the epochs&#39; losses during calculation.</span>
<span class="sd">    file_name : str, default = &#39;TEST&#39;</span>
<span class="sd">        The file name to be added to the report and image files.</span>
<span class="sd">    report_name : str, optional</span>
<span class="sd">        A name to add before the date in the report name.</span>
<span class="sd">    sim_loader : torch.utils.data.DataLoader, optional</span>
<span class="sd">        A DataLoader to be simulated during training, plotted in &quot;real time&quot; as</span>
<span class="sd">        the model learns. Not a necessary input,</span>
<span class="sd">        of course.</span>
<span class="sd">    Training_info : Training_Class, optional</span>
<span class="sd">        A Training_Class object to keep track of the training.</span>
<span class="sd">        Only entered as input if the model has already been trained.</span>
<span class="sd">    device : torch.device, default = &#39;cpu&#39;</span>
<span class="sd">        The device where the training should be run.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    Training_info : Training_Class</span>
<span class="sd">        The Training_Class object with all of the information related to the</span>
<span class="sd">        training.</span>
<span class="sd">    Total_error[-1] : torch.Tensor([float])</span>
<span class="sd">        Last epoch&#39;s training error.</span>
<span class="sd">    Valid_error[-1] : torch.Tensor([float])</span>
<span class="sd">        Last epoch&#39;s validation error [float]</span>
<span class="sd">    date : str</span>
<span class="sd">        The date and time at the beginning of the training. This is the name of</span>
<span class="sd">        the report when ``report=True``</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; from LSTM import *</span>
<span class="sd">    &gt;&gt;&gt; delta = 10</span>
<span class="sd">    &gt;&gt;&gt; hidden_dim = 20</span>
<span class="sd">    &gt;&gt;&gt; version = 4</span>
<span class="sd">    &gt;&gt;&gt; model = LSTM_v4(delta, hidden_dim, pooling_layer=&#39;bi_mean&#39;, version=version)</span>
<span class="sd">    &gt;&gt;&gt; with open(&#39;B0005.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="sd">    ...     Battery = pickle.load(f)</span>
<span class="sd">    ...</span>
<span class="sd">    &gt;&gt;&gt; train_dataset = Torch_Dataset_LSTM([Battery], delta, version, fixed_len=150)</span>
<span class="sd">    &gt;&gt;&gt; train_loader = DataLoader(dataset=train_dataset, batch_size=1, shuffle=True)</span>
<span class="sd">    &gt;&gt;&gt; with open(&#39;B0006.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="sd">    ...     Battery = pickle.load(f)</span>
<span class="sd">    ...</span>
<span class="sd">    &gt;&gt;&gt; valid_dataset = Torch_Dataset_LSTM([Battery], delta, version, fixed_len=150)</span>
<span class="sd">    &gt;&gt;&gt; valid_loader = DataLoader(dataset=valid_dataset, batch_size=len(valid_dataset),</span>
<span class="sd">    ... shuffle=False)</span>
<span class="sd">    &gt;&gt;&gt; N_epochs = 2</span>
<span class="sd">    &gt;&gt;&gt; Learning_Rate = 1e-5</span>
<span class="sd">    &gt;&gt;&gt; Train(train_loader, valid_loader, model, N_epochs, loss_fn=nn.L1Loss(),</span>
<span class="sd">    ... optimizer=th.optim.Adam(model.parameters(), Learning_Rate),</span>
<span class="sd">    ... LR = Learning_Rate)</span>
<span class="sd">    1 . Training loss:  tensor(0.8822)</span>
<span class="sd">    1 . Validation loss:  tensor(0.5137)</span>
<span class="sd">    2 . Training loss:  tensor(0.8365)</span>
<span class="sd">    2 . Validation loss:  tensor(0.4762)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="kn">import</span> <span class="nn">warnings</span>
    <span class="k">if</span> <span class="s1">&#39;report&#39;</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="p">:</span>
        <span class="n">warnings</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span>
            <span class="s2">&quot;&#39;report&#39; argument is always true&quot;</span><span class="p">,</span> <span class="ne">DeprecationWarning</span>
        <span class="p">)</span>

    <span class="k">if</span> <span class="s1">&#39;plot_bool&#39;</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="p">:</span>
        <span class="n">warnings</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span>
            <span class="s2">&quot;&#39;plot_bool argument is always true&#39;&quot;</span><span class="p">,</span> <span class="ne">DeprecationWarning</span>
        <span class="p">)</span>

    <span class="c1"># Initialization of loss function and optimizer:</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">loss_fn</span><span class="p">,</span> <span class="nb">type</span><span class="p">(</span><span class="kc">None</span><span class="p">)):</span>
        <span class="n">loss_fn</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">optimizer</span><span class="p">,</span> <span class="nb">type</span><span class="p">(</span><span class="kc">None</span><span class="p">)):</span>
        <span class="k">if</span> <span class="n">parameters</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">optimizer</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">optim</span><span class="o">.</span><span class="n">Adam</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">parameters</span><span class="p">(),</span> <span class="n">lr</span><span class="o">=</span><span class="n">LR</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">optimizer</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">optim</span><span class="o">.</span><span class="n">Adam</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="n">lr</span><span class="o">=</span><span class="n">LR</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">Training_info</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">Training_info</span> <span class="o">=</span> <span class="n">Training_Class</span><span class="p">(</span><span class="n">N_epochs</span><span class="p">,</span> <span class="n">loss_fn</span><span class="p">,</span> <span class="n">optimizer</span><span class="p">,</span> <span class="n">LR</span><span class="p">,</span>
                                       <span class="n">train_loader</span><span class="o">.</span><span class="n">batch_size</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">Training_info</span><span class="o">.</span><span class="n">learning_rate</span> <span class="o">!=</span> <span class="n">LR</span><span class="p">:</span>
            <span class="n">Training_info_save</span> <span class="o">=</span> <span class="n">Training_info</span>
            <span class="n">Training_info</span> <span class="o">=</span> <span class="n">Training_Class</span><span class="p">(</span><span class="n">N_epochs</span><span class="p">,</span> <span class="n">loss_fn</span><span class="p">,</span> <span class="n">optimizer</span><span class="p">,</span> <span class="n">LR</span><span class="p">)</span>
            <span class="n">Training_info</span><span class="o">.</span><span class="n">add_train</span><span class="p">(</span><span class="n">Training_info_save</span><span class="p">)</span>

    <span class="c1"># If a simulation loader has been called:</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">sim_loader</span><span class="p">,</span> <span class="nb">type</span><span class="p">(</span><span class="kc">None</span><span class="p">)):</span>
        <span class="n">sim_bool</span> <span class="o">=</span> <span class="kc">False</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">sim_bool</span> <span class="o">=</span> <span class="kc">True</span>

    <span class="n">date</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span>
    <span class="n">datetime</span><span class="o">.</span><span class="n">today</span><span class="p">()</span>
    <span class="p">)</span>  <span class="c1"># The current time will be used to distinguish it from others</span>
    <span class="n">date</span> <span class="o">=</span> <span class="n">date</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;:&#39;</span><span class="p">,</span> <span class="s1">&#39;_&#39;</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">report_name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">date</span> <span class="o">=</span> <span class="n">report_name</span><span class="o">+</span><span class="s1">&#39;-&#39;</span><span class="o">+</span><span class="n">date</span>
    <span class="c1"># Entering the report folder:</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports&#39;</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
        <span class="n">os</span><span class="o">.</span><span class="n">mkdir</span><span class="p">(</span><span class="s1">&#39;Reports&#39;</span><span class="p">)</span>             <span class="c1"># We&#39;ll create a reports folder</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports&#39;</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">mkdir</span><span class="p">(</span><span class="n">date</span><span class="p">)</span>                      <span class="c1"># Creating the report directory</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//&#39;</span> <span class="o">+</span> <span class="n">date</span><span class="p">)</span>              <span class="c1"># Entering it</span>

    <span class="c1"># Tensors for keeping the epochs&#39; losses:</span>
    <span class="n">Total_error</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="n">N_epochs</span><span class="p">)</span>     <span class="c1"># Total training loss (for each epoch)</span>
    <span class="n">Valid_error</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="n">N_epochs</span><span class="p">)</span>     <span class="c1"># Total validation loss (for each epoch)</span>

    <span class="c1"># Epoch Loop:</span>
    <span class="k">for</span> <span class="n">E</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">N_epochs</span><span class="p">):</span>
        <span class="n">Epoch_error</span> <span class="o">=</span> <span class="mi">0</span>         <span class="c1"># Initializing this epoch&#39;s loss</span>
        <span class="n">model</span><span class="o">.</span><span class="n">train</span><span class="p">()</span>           <span class="c1"># Making sure that the model is in training mode</span>

        <span class="c1"># Loader loop:</span>
        <span class="k">for</span> <span class="n">data</span><span class="p">,</span> <span class="n">label</span> <span class="ow">in</span> <span class="n">train_loader</span><span class="p">:</span>
            <span class="c1"># per batch:</span>
            <span class="n">data</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>      <span class="c1"># Bringing the data and the</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">label</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>    <span class="c1"># &quot;labels&quot; to the chosen device (cuda or cpu)</span>
            <span class="n">optimizer</span><span class="o">.</span><span class="n">zero_grad</span><span class="p">()</span>       <span class="c1"># Resetting the gradients</span>
            <span class="c1"># forward:</span>
            <span class="n">outputs</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">forward</span><span class="p">(</span><span class="n">data</span><span class="p">)</span>       <span class="c1"># Calculating the model&#39;s outputs</span>
            <span class="n">loss</span> <span class="o">=</span> <span class="n">loss_fn</span><span class="p">(</span><span class="n">outputs</span><span class="p">,</span> <span class="n">label</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">outputs</span><span class="p">),</span> <span class="o">-</span><span class="mi">1</span><span class="p">))</span>  <span class="c1"># Model&#39;s loss</span>
            <span class="c1"># backward:</span>
            <span class="n">loss</span><span class="o">.</span><span class="n">backward</span><span class="p">()</span>                     <span class="c1"># Gradient backpropagation</span>
            <span class="n">optimizer</span><span class="o">.</span><span class="n">step</span><span class="p">()</span>                    <span class="c1"># Parameter updates</span>
            <span class="n">Epoch_error</span> <span class="o">+=</span> <span class="n">loss</span><span class="o">.</span><span class="n">item</span><span class="p">()</span>          <span class="c1"># Adding this batch&#39;s loss to the the epoch loss.</span>

        <span class="n">Total_error</span><span class="p">[</span><span class="n">E</span><span class="p">]</span> <span class="o">=</span> <span class="n">Epoch_error</span> <span class="o">/</span> <span class="nb">len</span><span class="p">(</span><span class="n">train_loader</span><span class="p">)</span>  <span class="c1"># Saving the mean epoch error.</span>

        <span class="k">if</span> <span class="n">print_bool</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">E</span> <span class="o">+</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;. Training loss: &#39;</span><span class="p">,</span> <span class="n">Total_error</span><span class="p">[</span><span class="n">E</span><span class="p">])</span>    <span class="c1"># Printing epoch error</span>


        <span class="c1"># VALIDATION ERROR:</span>
        <span class="n">Partial_Valid_error</span> <span class="o">=</span> <span class="mi">0</span>  <span class="c1"># Initializing this epoch&#39;s validation loss</span>
        <span class="k">with</span> <span class="n">th</span><span class="o">.</span><span class="n">no_grad</span><span class="p">():</span>  <span class="c1"># Ignoring gradients, since no parameter updates will happen</span>
            <span class="n">model</span><span class="o">.</span><span class="n">eval</span><span class="p">()</span>    <span class="c1"># Setting the model to evaluation mode (no dropout etc.)</span>

            <span class="k">for</span> <span class="n">valid_data</span><span class="p">,</span> <span class="n">valid_label</span> <span class="ow">in</span> <span class="n">valid_loader</span><span class="p">:</span>
                <span class="c1"># per batch:</span>
                <span class="n">valid_data</span> <span class="o">=</span> <span class="n">valid_data</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>      <span class="c1"># Bringing the data and the</span>
                <span class="n">valid_label</span> <span class="o">=</span> <span class="n">valid_label</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>    <span class="c1"># &quot;labels&quot; to the chosen device (cuda or cpu)</span>
                <span class="c1"># forward:</span>
                <span class="n">valid_outputs</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">forward</span><span class="p">(</span><span class="n">valid_data</span><span class="p">)</span>   <span class="c1"># Model output</span>
                <span class="n">loss</span> <span class="o">=</span> <span class="n">loss_fn</span><span class="p">(</span><span class="n">valid_outputs</span><span class="p">,</span> <span class="n">valid_label</span><span class="p">)</span>  <span class="c1"># Validation error</span>
                <span class="n">Partial_Valid_error</span> <span class="o">+=</span> <span class="n">loss</span><span class="o">.</span><span class="n">item</span><span class="p">()</span>          <span class="c1"># Adding to the epoch&#39;s validation loss</span>

            <span class="n">Valid_error</span><span class="p">[</span><span class="n">E</span><span class="p">]</span> <span class="o">=</span> <span class="n">Partial_Valid_error</span> <span class="o">/</span> <span class="nb">len</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">)</span>    <span class="c1"># Saving the mean epoch validation error</span>

            <span class="k">if</span> <span class="n">print_bool</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span><span class="n">E</span> <span class="o">+</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;. Validation loss: &#39;</span><span class="p">,</span> <span class="n">Valid_error</span><span class="p">[</span><span class="n">E</span><span class="p">])</span>   <span class="c1"># Printing epoch&#39;s validation error</span>

            <span class="c1">## For saving each epoch&#39;s state_dict():</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Epochs&#39;</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
                <span class="n">os</span><span class="o">.</span><span class="n">mkdir</span><span class="p">(</span><span class="s1">&#39;Epochs&#39;</span><span class="p">)</span>
                <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Epochs&#39;</span><span class="p">)</span>
            <span class="n">th</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">state_dict</span><span class="p">(),</span> <span class="s1">&#39;Epoch_&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">E</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span><span class="p">)</span>
            <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>
            <span class="c1">##</span>

        <span class="n">model</span><span class="o">.</span><span class="n">train</span><span class="p">()</span>  <span class="c1"># Setting the model to training mode again (just in case)</span>

        <span class="c1"># Adding the epoch to the training class:</span>
        <span class="n">Training_info</span><span class="o">.</span><span class="n">add_epoch</span><span class="p">(</span><span class="n">Total_error</span><span class="p">[</span><span class="n">E</span><span class="p">],</span> <span class="n">Valid_error</span><span class="p">[</span><span class="n">E</span><span class="p">],</span> <span class="n">E</span><span class="p">)</span>

    <span class="c1"># Calculating the best epoch:</span>
    <span class="n">Training_info</span><span class="o">.</span><span class="n">best_epoch_method</span><span class="p">()</span>

    <span class="c1"># Creating the training curve:</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">19</span><span class="p">,</span> <span class="mi">10</span><span class="p">))</span>            <span class="c1"># Creating a figure</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">N_epochs</span><span class="o">+</span><span class="mi">1</span><span class="p">),</span> <span class="n">Total_error</span><span class="o">.</span><span class="n">detach</span><span class="p">()</span><span class="o">.</span><span class="n">numpy</span><span class="p">(),</span>
             <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Training&#39;</span><span class="p">)</span>  <span class="c1"># Plotting the training lossees</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">N_epochs</span><span class="o">+</span><span class="mi">1</span><span class="p">),</span> <span class="n">Valid_error</span><span class="o">.</span><span class="n">detach</span><span class="p">()</span><span class="o">.</span><span class="n">numpy</span><span class="p">(),</span>
             <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Validation&#39;</span><span class="p">)</span>  <span class="c1"># Plotting the validation losses</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s1">&#39;Loss&#39;</span><span class="p">)</span>                       <span class="c1"># Plot title</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;Epoch Number&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;Loss&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ioff</span><span class="p">()</span>

    <span class="k">try</span><span class="p">:</span>  <span class="c1"># Try to enter an image folder</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Images&#39;</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>  <span class="c1"># If there&#39;s no Image folder</span>
        <span class="n">os</span><span class="o">.</span><span class="n">mkdir</span><span class="p">(</span><span class="s1">&#39;Images&#39;</span><span class="p">)</span>  <span class="c1"># Create one</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Images&#39;</span><span class="p">)</span>  <span class="c1"># Enter it</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">file_name</span> <span class="o">+</span> <span class="s1">&#39;_losses.png&#39;</span><span class="p">)</span>       <span class="c1"># Saving the image</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>  <span class="c1"># Go back to the previous folder</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>                             <span class="c1"># Close the image</span>

    <span class="n">Report</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Training_info</span><span class="p">,</span>
           <span class="n">file_name</span><span class="o">=</span><span class="n">file_name</span><span class="o">+</span><span class="s1">&#39;_report&#39;</span><span class="p">,</span> <span class="n">remove_files</span><span class="o">=</span><span class="n">remove_bool</span><span class="p">)</span>

    <span class="n">model</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">sim_bool</span><span class="p">:</span>    <span class="c1"># If we want to simulate the results</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;base_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
        <span class="n">simulate</span><span class="p">(</span>
            <span class="n">sim_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;Training_base&#39;</span><span class="p">,</span>
            <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Training Dataset (Final epoch)&#39;</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
            <span class="n">device</span><span class="o">=</span><span class="n">device</span>
        <span class="p">)</span>
        <span class="n">simulate</span><span class="p">(</span>
            <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;Validation_base&#39;</span><span class="p">,</span>
            <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Validation Dataset (Final epoch)&#39;</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
            <span class="n">device</span><span class="o">=</span><span class="n">device</span>
        <span class="p">)</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
            <span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
            <span class="n">simulate</span><span class="p">(</span>
                <span class="n">sim_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;Training_best&#39;</span><span class="p">,</span>
                <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Training Dataset (Best epoch)&#39;</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                <span class="n">device</span><span class="o">=</span><span class="n">device</span>
            <span class="p">)</span>
            <span class="n">simulate</span><span class="p">(</span>
                <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;Validation_best&#39;</span><span class="p">,</span>
                <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Validation Dataset (Best epoch)&#39;</span><span class="p">,</span>
                <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span>
            <span class="p">)</span>

        <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;No best model found.&#39;</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Best validation error: &#39;</span><span class="p">,</span> <span class="n">th</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span><span class="n">Valid_error</span><span class="p">)</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>

    <span class="c1"># Leave the report folder:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">Training_info</span><span class="p">,</span> <span class="n">Total_error</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">Valid_error</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">date</span>     <span class="c1"># Gives back the Training Class and the last epoch&#39;s training and validation errors.</span></div>


<div class="viewcode-block" id="simulate"><a class="viewcode-back" href="../sphinx/Training.html#Training.simulate">[docs]</a><span class="k">def</span> <span class="nf">simulate</span><span class="p">(</span><span class="n">sim_loader</span><span class="p">,</span> <span class="n">model</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
             <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;Capacity&#39;</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="s1">&#39;cpu&#39;</span><span class="p">,</span> <span class="n">Time_stamps</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
             <span class="n">block</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Simulation&#39;</span><span class="p">,</span> <span class="n">dir_name</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">,</span>
             <span class="n">fixed_lims</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>

    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function for simulating a model&#39;s performance on a dataset.</span>
<span class="sd">    This will create a plot where the model&#39;s outputs are shown in blue and the</span>
<span class="sd">    labels/real values are shown in orange.</span>

<span class="sd">    If report = True, then it will save the plot as an image in the &quot;Images&quot;</span>
<span class="sd">    folder.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    sim_loader : torch.utils.data.DataLoader</span>
<span class="sd">        The dataset&#39;s DataLoader.</span>
<span class="sd">    model : torch.nn.Module</span>
<span class="sd">        The model we want to test.</span>
<span class="sd">    report : bool, default = False</span>
<span class="sd">        Whether or not we want to save an image of the simulation.</span>
<span class="sd">    plot_bool : bool, default = True</span>
<span class="sd">        Whether or not we want to show the plot.</span>
<span class="sd">    file_name : str, default = Capacity</span>
<span class="sd">        File name for the saved plot.</span>
<span class="sd">    device : torch.device or str, default = &#39;cpu&#39;</span>
<span class="sd">        The device where we want to do the calculations on.</span>
<span class="sd">    Time_stamps : array_like, optional</span>
<span class="sd">        Dataset&#39;s time stamps.</span>
<span class="sd">    block: bool, default = True</span>
<span class="sd">        Whether or not the plot should stop the code from continuing.</span>
<span class="sd">        if block == False, then the plot will be shown for 5 seconds.</span>
<span class="sd">    denormalize : bool, default = True</span>
<span class="sd">        Whether or not we want the plot to show the de-normalized values or not.</span>
<span class="sd">        if denormalize == False, then the plot will show the model&#39;s output and</span>
<span class="sd">        the labels in their normalized form.</span>
<span class="sd">    title : str, default = &#39;Simulation&#39;</span>
<span class="sd">        The plot&#39;s title.</span>
<span class="sd">    dir_name : str, optional</span>
<span class="sd">        A string to add to the Image directory name in order to differentiate</span>
<span class="sd">        it. For instance, if dir_name=&#39;_Final&#39; then the images will be saved in</span>
<span class="sd">        directory &#39;Images_Final&#39; (if the directory doesn&#39;t exist it will be</span>
<span class="sd">        created).</span>
<span class="sd">    fixed_lims : bool, default = True</span>
<span class="sd">        Whether or not to fix the y-axis limits between -0.1 and 1.1.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">try</span><span class="p">:</span>
        <span class="n">norm</span> <span class="o">=</span> <span class="n">sim_loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">norm</span>
    <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
        <span class="n">norm</span> <span class="o">=</span> <span class="kc">None</span>

    <span class="k">with</span> <span class="n">th</span><span class="o">.</span><span class="n">no_grad</span><span class="p">():</span>  <span class="c1"># Ignoring gradients, since no parameter updates will happen</span>

        <span class="n">model</span><span class="o">.</span><span class="n">eval</span><span class="p">()</span>  <span class="c1"># Setting the model to evaluation mode</span>

        <span class="n">sim_output_plot</span> <span class="o">=</span> <span class="p">[]</span>    <span class="c1"># For plotting purposes</span>
        <span class="n">sim_labels_plot</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">data</span><span class="p">,</span> <span class="n">labels</span> <span class="ow">in</span> <span class="n">sim_loader</span><span class="p">:</span>
            <span class="c1"># per batch:</span>
            <span class="n">data</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>          <span class="c1"># Bringing the data and the</span>
            <span class="n">labels</span> <span class="o">=</span> <span class="n">labels</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>      <span class="c1"># &quot;labels&quot; to the chosen device (cuda or cpu)</span>
            <span class="c1"># forward</span>
            <span class="n">sim_output</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">forward</span><span class="p">(</span><span class="n">data</span><span class="p">)</span>  <span class="c1"># Saída do modelo</span>
            <span class="n">sim_labels</span> <span class="o">=</span> <span class="n">labels</span>

            <span class="c1"># Adding them to the list for plotting:</span>
            <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sim_output</span><span class="p">)</span>
            <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sim_labels</span><span class="p">)</span>

        <span class="c1"># Turning the lists into torch tensors</span>
        <span class="n">sim_output_plot</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="p">)</span>
        <span class="n">sim_labels_plot</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">(</span><span class="n">sim_labels_plot</span><span class="p">)</span>

        <span class="n">sim_output_plot</span> <span class="o">=</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span>
        <span class="n">sim_labels_plot</span> <span class="o">=</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span>

        <span class="c1"># Adjusting their shape</span>
        <span class="n">sim_output_plot</span> <span class="o">=</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">max</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="o">.</span><span class="n">shape</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>
        <span class="n">sim_labels_plot</span> <span class="o">=</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">max</span><span class="p">(</span><span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">shape</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">denormalize</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">norm</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;zscore&#39;</span><span class="p">:</span>
                    <span class="n">sim_output_plot</span> <span class="o">=</span> <span class="n">sim_output_plot</span><span class="o">*</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">+</span><span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
                    <span class="n">sim_labels_plot</span> <span class="o">=</span> <span class="n">sim_labels_plot</span><span class="o">*</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">+</span><span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
                <span class="k">elif</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;minmax&#39;</span><span class="p">:</span>
                    <span class="n">sim_output_plot</span> <span class="o">=</span> <span class="n">sim_output_plot</span><span class="o">*</span><span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span><span class="o">+</span><span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
                    <span class="n">sim_labels_plot</span> <span class="o">=</span> <span class="n">sim_labels_plot</span><span class="o">*</span><span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span><span class="o">+</span><span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">report</span><span class="p">:</span>

            <span class="k">try</span><span class="p">:</span>  <span class="c1"># Try to enter an image folder</span>
                <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Images&#39;</span><span class="o">+</span><span class="n">dir_name</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>  <span class="c1"># If there&#39;s no Image folder</span>
                <span class="n">os</span><span class="o">.</span><span class="n">mkdir</span><span class="p">(</span><span class="s1">&#39;Images&#39;</span><span class="o">+</span><span class="n">dir_name</span><span class="p">)</span>  <span class="c1"># Create one</span>
                <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Images&#39;</span><span class="o">+</span><span class="n">dir_name</span><span class="p">)</span>  <span class="c1"># Enter it</span>

            <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">14</span><span class="p">,</span> <span class="mi">5</span><span class="p">))</span>            <span class="c1"># Creating a figure</span>

            <span class="k">if</span> <span class="n">Time_stamps</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>     <span class="c1"># If the time stamps are available</span>
                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>                       <span class="c1"># If not</span>
                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>

            <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="n">title</span><span class="p">)</span>         <span class="c1"># Plot title</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;Cycle number&#39;</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;SOH&#39;</span><span class="p">)</span>

            <span class="k">if</span> <span class="n">fixed_lims</span><span class="p">:</span>
                <span class="n">ylim_max</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="p">)</span><span class="o">.</span><span class="n">item</span><span class="p">()</span> <span class="o">+</span> <span class="mf">0.1</span><span class="p">,</span> <span class="mf">1.1</span><span class="p">)</span>
                <span class="n">ylim_min</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">amin</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="p">)</span><span class="o">.</span><span class="n">item</span><span class="p">()</span> <span class="o">-</span> <span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.1</span><span class="p">)</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">ylim</span><span class="p">([</span><span class="n">ylim_min</span><span class="p">,</span> <span class="n">ylim_max</span><span class="p">])</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">pass</span>

            <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">ioff</span><span class="p">()</span>                      <span class="c1"># Stopping a plot window to be made</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">file_name</span> <span class="o">+</span> <span class="s1">&#39;.png&#39;</span><span class="p">)</span> <span class="c1"># Saving the figure</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>                     <span class="c1"># Closing the figure</span>

            <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>                 <span class="c1"># Going back to the original folder</span>

    <span class="k">if</span> <span class="n">plot_bool</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">Time_stamps</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>  <span class="c1"># If the time stamps are available</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">Time_stamps</span><span class="p">,</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>  <span class="c1"># If not</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">)</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">sim_labels_plot</span><span class="o">.</span><span class="n">cpu</span><span class="p">(),</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Experiment&#39;</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="n">title</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">fixed_lims</span><span class="p">:</span>
            <span class="n">ylim_max</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="p">)</span><span class="o">.</span><span class="n">item</span><span class="p">()</span> <span class="o">+</span> <span class="mf">0.1</span><span class="p">,</span> <span class="mf">1.1</span><span class="p">)</span>
            <span class="n">ylim_min</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">amin</span><span class="p">(</span><span class="n">sim_output_plot</span><span class="p">)</span><span class="o">.</span><span class="n">item</span><span class="p">()</span> <span class="o">-</span> <span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.1</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">ylim</span><span class="p">([</span><span class="n">ylim_min</span><span class="p">,</span> <span class="n">ylim_max</span><span class="p">])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">pass</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;Cycle number&#39;</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;SOH&#39;</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">block</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">(</span><span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">pause</span><span class="p">(</span><span class="mi">5</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>